/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.model.CatalogCategoryModel");

dojo.require("com.ibm.mashups.enabler.Deferred");
dojo.require("com.ibm.mashups.enabler.TreeModelController");
dojo.require("com.ibm.mashups.enabler.model.CatalogEntryModel");
dojo.require("com.ibm.mashups.enabler.catalog.CatalogCategoryNode");
//<INTERFACE>
/**
 * Interface for a catalog model containing category nodes. This tree model
 * describes the topology in which the categories are structured.
 * As of now only one level below the root is supported; no child categories.
 * @ibm-api
 * @ibm-module CatalogModel
 */
dojo.declare("com.ibm.mashups.enabler.model.CatalogCategoryModel", com.ibm.mashups.enabler.TreeModelController, {
    /**
     * Returns the catalog entry model for the given category.
     * @param {com.ibm.mashups.enabler.catalog.CatalogCategoryNode} category the CatalogCategoryNode for which
     * to return the CatalogEntryModel; must not be <code>null</code>
     * @type com.ibm.mashups.enabler.catalog.CatalogEntryModel
     * @return catalog entry model for given category, Never <code>null</code>.
     */
    getCatalogEntryModel: function(category){
    },
    
    /**
     * creates a new CatalogCategoryNode. The created node can be inserted into
     * the model using an appropriate <code>insert</code> method. The node will
     * not appear in the model unless it is inserted.
     * @param {JSON} context array of predefined information
     * used for the creation of the node. May be <code>null</code>. Accepted names are:<br>
     * &nbsp;&nbsp;&nbsp;&nbsp;<code>category</code> - the name of the category
     * to be created (mandatory)<br>
     * @type com.ibm.mashups.enabler.catalog.CatalogCategoryNode
     * @return the created node
     */
    create: function(context){
    },
    
    /**
     * Commits the modifications applied to this model and all dependent models.<br>
     * @return {DeferredOperation} a deferred object used to start this operation. 
     * The return value when executed through the deferred object is <code>null</null>
     */
    commit: function(){
    }
});
//</INTERFACE>

dojo.require("com.ibm.mm.enabler.catalog.CatalogCategoryModelImpl");
