/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.widget.Preferences");

/**
 * An interface representing preferences. It can be obtained through an&nbsp; {@link com.ibm.mashups.enabler.widget.PreferencesProvider PreferencesProvider}.
 * @since 2.4
 *
 * @ibm-api
 * @ibm-module WidgetModel
 */
dojo.declare("com.ibm.mashups.enabler.widget.Preferences", null, {
    /**
     * Returns the preference value for the given preference name. 
     * If there are multiple values for the given preference, the first value will be returned.
     * @param {String} name the preference name. Must not be <tt>null</tt>
     * @return {String} the preference value or <code>null</code>, if the preference is not set.
     */
    getValue: function(name) {
    },
    /**
     * Returns the preference values for the given preference name.
     * @param {String} name the preference name. Must not be <tt>null</tt>
     * @return {String[]} the preference values or <code>null</code>, if the preference is not set.
     */
    getValues: function(name) {
    },
    
    /**
     * Return <code>true</code> if the preference is set and marked as read-only in the widget definition, <code>false</code> otherwise.
     * @param {String} name the preference key. Must not be <tt>null</tt>
     * @return {boolean} <code>true</code> if the preference is set and marked as read-only
     */
    isReadOnly: function(name) {
    },
    
    /**
     * Returns a list of the names of preference entries.
     * @return {String[]} the list of names.
     */
    getNames: function() {
    },
    /**
     * Returns a map of all the preferences, with the name as key and the first value only as child.
     * @return {Map} a JSON object representing a map, never <code>null</code>
     */
    getMap: function() {
    }
});

