/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.widget.WidgetDefinition");

dojo.require("com.ibm.mashups.enabler.Identifiable");
dojo.require("com.ibm.mashups.enabler.ModifiableLocalized");
dojo.require("com.ibm.mashups.enabler.ModifiableMetaData");
dojo.require("com.ibm.mashups.enabler.widget.PreferencesProvider");
dojo.require("com.ibm.mashups.enabler.widget.ModifiableEventProvider");

//<INTERFACE>
/**
 * Interface for a widget definition.
 *
 * @ibm-api
 * @ibm-module WidgetModel
 */
dojo.declare("com.ibm.mashups.enabler.widget.WidgetDefinition", [com.ibm.mashups.enabler.Identifiable, com.ibm.mashups.enabler.ModifiableLocalized, com.ibm.mashups.enabler.ModifiableMetaData, com.ibm.mashups.enabler.widget.PreferencesProvider, com.ibm.mashups.enabler.widget.ModifiableEventProvider], {
    /**
     * @private
     */
    _type: "definition",
    
    /**
     * This method returns the url pointing to the widget definition xml file.
     * @return{String}  URL pointing to the widget definition xml file.
     *
     * @since 3.0
     */
    getURL: function() {
    },
    
    /**
     * This method returns the type of the entity represented by this definition (e.g. iWidgets or OpenSocial gadget).
     * @return{String}  the type of the entity represented in the definition xml file.
     *
     * @since 3.0
     */
    getType: function() {
    },
    
    /**
     * This method returns an array of supported modes such as &quot;view&quot; and &quot;edit&quot;.
     * @return{String[]}  an array of modes this iWidget supports.
     *
     * @since 2.4
     */
    getSupportedModes: function() {
    }
});
//</INTERFACE>
dojo.require("com.ibm.mm.iwidget.widget.IWidgetDefinitionDefaultImpl");
