/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.iwidget.widget.Properties");

//<INTERFACE>
/**
 * Interface defines functions to iterates , updates and persist Properties.
 * @ibm-spi
 * @ibm-module iWidget2
 */
dojo.declare("com.ibm.mashups.iwidget.widget.Properties", null, {
    /**
     * @private
     */
    constructor: function() {
    },
    /**
     * This method returns the value of the required item
     * @param{String} itemName name of the item.Must never be NULL.
     * @param{String} locale the locale of the value to fetch. if locale isn't defined, the
     *                <code>DEFAULT_LOCALE</code> will be used
     * @return{String}  return the  value of required item
     */
    getItemValue: function(/*String*/itemName, locale) {
    
    },
    /**
     * This method returns an array of Strings,providing the name of each item.
     * @return{String[]}  return an array of items names and return NULL if the set contains no item
     */
    getAllNames: function() {
        return null;
    },
    
    /**
     * This methods returns the locales for the item specified by <code>itemName</code>
     * @param{String} itemName the name of the item for which do get the locales.
     * @return{String[]} return an array of locales valid for the specified itemName, returns an empty array if no localized item values are available.
     */
    getItemLocales: function(itemName) {
    },
    /**
     * This method allows the caller to check whether a specific item is readOnly or not.
     * @param{String} itemName the item name of the item to check readOnly
     * @return{Boolean} <code>true</code> if the item exists and is read only, <code>false</code> otherwise.
     */
    isReadOnly: function(itemName) {
    }
});
//</INTERFACE>
dojo.require("com.ibm.mm.iwidget.widget.PropertiesImpl");
